/***************************************************************************\
*                                                                           *
* File: local.h                                                             *
*                                                                           *
* Desc: Header file with typedefs, constants, macros, etc. used by all      *
*       projects at this facility.                                          *
*                                                                           *
* Vers: 1.00    Jim Roberts                                                 *
*                                                                           *
\***************************************************************************/

/***************************************************************************\
*                F u n c t i o n   A c c e s s   T y p e s                  *
\***************************************************************************/
                
#define Private                        /* Function access types. C++ idea  */
#define Public                         /* that wasn't implemented there.   */

/***************************************************************************\
*              B o o l e a n   E n u m e r a t e d   T y p e                *
\***************************************************************************/

#if !defined _Boolean_
#define _Boolean_

typedef enum
   {
   _False = 0,
   _True  = !_False
   } Boolean;

#endif /* _Boolean_ */

/***************************************************************************\
*                                                                           *
* The following #define for  ptr_t  will define the type of pointers that   *
* are being defined for a project.  To compare memory addresses, the space  *
* has to be well ordered.  This is not a problem if the address space is    *
* the Tiny, Small, or Medium memory model.                                  *
*                                                                           *
* For the Compact, Large, and Huge memory models, memory is addrressed by   *
* a Segment:Offset pair which does not require a unique address for a       *
* memory location.                                                          *
*                                                                           *
* To further complicate matters, the memory model you use deligates the     *
* set of libraries that you will link to.  There is a version of  printf()  *
* for the different models; one accepting a 16-bit Segment alone (for the   *
* Tiny, Small, and Medium memory models) for pointers and the other which   *
* expects 32-bit Segment:Offset addresses.                                  *
*                                                                           *
* To properly address memory as a well ordered space using whatever memory  *
* model is used for a project, the term 'ptr_t' is defined which will make  *
* a pointer expression generate a unique, well ordered address in the       *
* Compact, Large, and Huge memory models and, at the same time, generates   *
* a 16-bit or 32-bit addresses to interface to whichever of the standard C  *
* libraries used by the project.                                            *
*                                                                           *
\***************************************************************************/

#if !defined ptr_t
   #if defined(__LARGE__) || defined(__HUGE__) || defined(__COMPACT__)
      #define ptr_t huge
   #else
      #define ptr_t
   #endif
#endif

/* End of File */
